.386
.387

;---------------------------------------;
;     *TEXTURE MAPPING  INNER LOOP*     ;
;    !Numeric processor is required!    ;
;                                       ;
;     (c) 1999 by Alexei A. Frounze     ;
; Homepage: http://www.chat.ru/~alexfru ;
;        E-mail: alexfru@chat.ru        ;
;---------------------------------------;

TEXTURE_BITS    EQU     7
TEXTURE_SIZE    EQU     1 SHL TEXTURE_BITS
IBits3          EQU     3
ICnt3           EQU     1 SHL IBits3
IBits4          EQU     4
ICnt4           EQU     1 SHL IBits4

PUBLIC          TLINE8, TLINE16

EXTRN           VSegA : WORD

CODE    SEGMENT PARA PUBLIC USE16
        ASSUME CS:CODE,DS:CODE

;------------------------------------------------------------;
;        !!! ;
;            !!!    !!!             ;
;           8/16      ;
;------------------------------------------------------------;

TLINE8  PROC PASCAL FAR
;(VOFFS : Word; LLEN : Word; PTEXTURE : DWord; L3, L1, L2, I3, I1, I2 : Comp)
LOCAL ZINV : QWORD, I : WORD, N : WORD, U : DWORD, V : DWORD
LOCAL U1 : QWORD, V1 : QWORD, U2 : QWORD, V2 : QWORD, DU : DWORD, DV : DWORD
LOCAL N128 : WORD

I2              EQU     SS:[BP+6]
I1              EQU     SS:[BP+14]
I3              EQU     SS:[BP+22]
L2              EQU     SS:[BP+30]
L1              EQU     SS:[BP+38]
L3              EQU     SS:[BP+46]
PTEXTURE        EQU     SS:[BP+54]
LLEN            EQU     SS:[BP+58]
VOFFS           EQU     SS:[BP+60]

        Push    DS

        Mov     N128, TEXTURE_SIZE

        Mov     EAX, DWord Ptr I1
        Mov     EDX, DWord Ptr I1+4
        SHLD    EDX, EAX, IBits3
        SHL     EAX, IBits3
        Mov     DWord Ptr I1+4, EDX
        Mov     DWord Ptr I1, EAX

        Mov     EAX, DWord Ptr I2
        Mov     EDX, DWord Ptr I2+4
        SHLD    EDX, EAX, IBits3
        SHL     EAX, IBits3
        Mov     DWord Ptr I2+4, EDX
        Mov     DWord Ptr I2, EAX

        Mov     EAX, DWord Ptr I3
        Mov     EDX, DWord Ptr I3+4
        SHLD    EDX, EAX, IBits3
        SHL     EAX, IBits3
        Mov     DWord Ptr I3+4, EDX
        Mov     DWord Ptr I3, EAX

        FILD    N128
;---------------------
        Mov     EAX, DWord Ptr L3
        Mov     EDX, DWord Ptr L3+4
        Or      EAX, EDX
        JNZ     @@isok1
        Jmp     @@done1
@@isok1:
        FILD    QWord Ptr L3
        FDiv
@@done1:
;---------------------
        FST     ZINV
        FILD    QWord Ptr L2
        FMul    ST, ST(1)
        FISTP   U1
        FILD    QWord Ptr L1
        FMul
        FISTP   V1

        Mov     EAX, DWord Ptr I1
        Add     DWord Ptr L1, EAX
        Mov     EDX, DWord Ptr I1+4
        AdC     DWord Ptr L1+4, EDX

        Mov     EAX, DWord Ptr I2
        Add     DWord Ptr L2, EAX
        Mov     EDX, DWord Ptr I2+4
        AdC     DWord Ptr L2+4, EDX

        Mov     EAX, DWord Ptr I3
        Add     DWord Ptr L3, EAX
        Mov     EDX, DWord Ptr I3+4
        AdC     DWord Ptr L3+4, EDX

        FILD    N128
;---------------------
        Mov     EAX, DWord Ptr L3
        Mov     EDX, DWord Ptr L3+4
        OR      EAX, EDX
        JNZ     @@isok2
        Jmp     @@done2
@@isok2:
        FILD    QWord Ptr L3
        FDiv
@@done2:
;---------------------
        FST     ZINV
        FILD    QWord Ptr L2
        FMul    ST, ST(1)
        FISTP   U2
        FILD    QWord Ptr L1
        FMul
        FISTP   V2

        Mov     EAX, DWord Ptr U2
        Sub     EAX, DWord Ptr U1
;        JC      @@nfix1
;        Cmp     EAX, -ICnt3
;        JC      @@nfix1
;        Xor     EAX, EAX
;@@nfix1:
        Sar     EAX, IBits3
        Mov     DU, EAX

        Mov     EAX, DWord Ptr V2
        Sub     EAX, DWord Ptr V1
;        JC      @@nfix2
;        Cmp     EAX, -ICnt3
;        JC      @@nfix2
;        Xor     EAX, EAX
;@@nfix2:
        Sar     EAX, IBits3
        Mov     DV, EAX

        Mov     ES, VSegA
        Mov     DI, VOFFS
        Mov     DS, Word Ptr PTexture+2
        CLD

        Mov     AX, LLEN
        Mov     I, AX

@@mcycle:

        Mov     N, ICnt3
        Sub     I, ICnt3
        Jnc     @@b
        Mov     AX, I
        Add     N, AX
@@b:
        Mov     BX, Word Ptr U1
        Mov     DX, Word Ptr V1

        Mov     CX, N

@@cycle:

        Mov     SI, BX
        And     SI, (TEXTURE_SIZE-1) SHL TEXTURE_BITS
        Mov     AX, DX
        Shr     AX, TEXTURE_BITS
        And     AX, TEXTURE_SIZE-1
        Add     SI, AX
        Add     SI, Word Ptr PTexture

        MovSB

        Add     BX, Word Ptr DU
        Add     DX, Word Ptr DV

        Loop    @@cycle

        Mov     AX, I
        OR      AX, AX
        JZ      @@done
        Test    AX, 8000h
        JNZ     @@done

        Mov     EAX, DWord Ptr U2
        Mov     DWord Ptr U1, EAX

        Mov     EAX, DWord Ptr V2
        Mov     DWord Ptr V1, EAX


        Mov     EAX, DWord Ptr I1
        Add     DWord Ptr L1, EAX
        Mov     EDX, DWord Ptr I1+4
        AdC     DWord Ptr L1+4, EDX

        Mov     EAX, DWord Ptr I2
        Add     DWord Ptr L2, EAX
        Mov     EDX, DWord Ptr I2+4
        AdC     DWord Ptr L2+4, EDX

        Mov     EAX, DWord Ptr I3
        Add     DWord Ptr L3, EAX
        Mov     EDX, DWord Ptr I3+4
        AdC     DWord Ptr L3+4, EDX


        FILD    N128
;---------------------
        Mov     EAX, DWord Ptr L3
        Mov     EDX, DWord Ptr L3+4
        OR      EAX, EDX
        JNZ     @@isok3
        Jmp     @@done3
@@isok3:
        FILD    QWord Ptr L3
        FDiv
@@done3:
;---------------------
        FST     ZINV
        FILD    QWord Ptr L2
        FMul    ST, ST(1)
        FISTP   U2
        FILD    QWord Ptr L1
        FMul
        FISTP   V2

        Mov     EAX, DWord Ptr U2
        Sub     EAX, DWord Ptr U1
;        JC      @@nfix3
;        Cmp     EAX, -ICnt3
;        JC      @@nfix3
;        Xor     EAX, EAX
;@@nfix3:
        Sar     EAX, IBits3
        Mov     DU, EAX

        Mov     EAX, DWord Ptr V2
        Sub     EAX, DWord Ptr V1
;        JC      @@nfix4
;        Cmp     EAX, -ICnt3
;        JC      @@nfix4
;        Xor     EAX, EAX
;@@nfix4:
        Sar     EAX, IBits3
        Mov     DV, EAX

        Jmp     @@mcycle

@@done:

        Pop     DS
        Ret
TLINE8  ENDP

TLINE16 PROC PASCAL FAR
;(VOFFS : Word; LLEN : Word; PTEXTURE : DWord; L3, L1, L2, I3, I1, I2 : Comp)
LOCAL ZINV : QWORD, I : WORD, N : WORD, U : DWORD, V : DWORD
LOCAL U1 : QWORD, V1 : QWORD, U2 : QWORD, V2 : QWORD, DU : DWORD, DV : DWORD
LOCAL N128 : WORD

I2              EQU     SS:[BP+6]
I1              EQU     SS:[BP+14]
I3              EQU     SS:[BP+22]
L2              EQU     SS:[BP+30]
L1              EQU     SS:[BP+38]
L3              EQU     SS:[BP+46]
PTEXTURE        EQU     SS:[BP+54]
LLEN            EQU     SS:[BP+58]
VOFFS           EQU     SS:[BP+60]

        Push    DS

        Mov     N128, TEXTURE_SIZE

        Mov     EAX, DWord Ptr I1
        Mov     EDX, DWord Ptr I1+4
        SHLD    EDX, EAX, IBits4
        SHL     EAX, IBits4
        Mov     DWord Ptr I1+4, EDX
        Mov     DWord Ptr I1, EAX

        Mov     EAX, DWord Ptr I2
        Mov     EDX, DWord Ptr I2+4
        SHLD    EDX, EAX, IBits4
        SHL     EAX, IBits4
        Mov     DWord Ptr I2+4, EDX
        Mov     DWord Ptr I2, EAX

        Mov     EAX, DWord Ptr I3
        Mov     EDX, DWord Ptr I3+4
        SHLD    EDX, EAX, IBits4
        SHL     EAX, IBits4
        Mov     DWord Ptr I3+4, EDX
        Mov     DWord Ptr I3, EAX

        FILD    N128
;---------------------
        Mov     EAX, DWord Ptr L3
        Mov     EDX, DWord Ptr L3+4
        Or      EAX, EDX
        JNZ     @@_isok1
        Jmp     @@_done1
@@_isok1:
        FILD    QWord Ptr L3
        FDiv
@@_done1:
;---------------------
        FST     ZINV
        FILD    QWord Ptr L2
        FMul    ST, ST(1)
        FISTP   U1
        FILD    QWord Ptr L1
        FMul
        FISTP   V1

        Mov     EAX, DWord Ptr I1
        Add     DWord Ptr L1, EAX
        Mov     EDX, DWord Ptr I1+4
        AdC     DWord Ptr L1+4, EDX

        Mov     EAX, DWord Ptr I2
        Add     DWord Ptr L2, EAX
        Mov     EDX, DWord Ptr I2+4
        AdC     DWord Ptr L2+4, EDX

        Mov     EAX, DWord Ptr I3
        Add     DWord Ptr L3, EAX
        Mov     EDX, DWord Ptr I3+4
        AdC     DWord Ptr L3+4, EDX

        FILD    N128
;---------------------
        Mov     EAX, DWord Ptr L3
        Mov     EDX, DWord Ptr L3+4
        OR      EAX, EDX
        JNZ     @@_isok2
        Jmp     @@_done2
@@_isok2:
        FILD    QWord Ptr L3
        FDiv
@@_done2:
;---------------------
        FST     ZINV
        FILD    QWord Ptr L2
        FMul    ST, ST(1)
        FISTP   U2
        FILD    QWord Ptr L1
        FMul
        FISTP   V2

        Mov     EAX, DWord Ptr U2
        Sub     EAX, DWord Ptr U1
;        JC      @@_nfix1
;        Cmp     EAX, -ICnt4
;        JC      @@_nfix1
;        Xor     EAX, EAX
;@@_nfix1:
        Sar     EAX, IBits4
        Mov     DU, EAX

        Mov     EAX, DWord Ptr V2
        Sub     EAX, DWord Ptr V1
;        JC      @@_nfix2
;        Cmp     EAX, -ICnt4
;        JC      @@_nfix2
;        Xor     EAX, EAX
;@@_nfix2:
        Sar     EAX, IBits4
        Mov     DV, EAX

        Mov     ES, VSegA
        Mov     DI, VOFFS
        Mov     DS, Word Ptr PTexture+2
        CLD

        Mov     AX, LLEN
        Mov     I, AX

@@_mcycle:

        Mov     N, ICnt4
        Sub     I, ICnt4
        Jnc     @@_b
        Mov     AX, I
        Add     N, AX
@@_b:
        Mov     BX, Word Ptr U1
        Mov     DX, Word Ptr V1

        Mov     CX, N

@@_cycle:

        Mov     SI, BX
        And     SI, (TEXTURE_SIZE-1) SHL TEXTURE_BITS
        Mov     AX, DX
        Shr     AX, TEXTURE_BITS
        And     AX, TEXTURE_SIZE-1
        Add     SI, AX
        Add     SI, Word Ptr PTexture

        MovSB

        Add     BX, Word Ptr DU
        Add     DX, Word Ptr DV

        Loop    @@_cycle

        Mov     AX, I
        OR      AX, AX
        JZ      @@_done
        Test    AX, 8000h
        JNZ     @@_done

        Mov     EAX, DWord Ptr U2
        Mov     DWord Ptr U1, EAX

        Mov     EAX, DWord Ptr V2
        Mov     DWord Ptr V1, EAX


        Mov     EAX, DWord Ptr I1
        Add     DWord Ptr L1, EAX
        Mov     EDX, DWord Ptr I1+4
        AdC     DWord Ptr L1+4, EDX

        Mov     EAX, DWord Ptr I2
        Add     DWord Ptr L2, EAX
        Mov     EDX, DWord Ptr I2+4
        AdC     DWord Ptr L2+4, EDX

        Mov     EAX, DWord Ptr I3
        Add     DWord Ptr L3, EAX
        Mov     EDX, DWord Ptr I3+4
        AdC     DWord Ptr L3+4, EDX


        FILD    N128
;---------------------
        Mov     EAX, DWord Ptr L3
        Mov     EDX, DWord Ptr L3+4
        OR      EAX, EDX
        JNZ     @@_isok3
        Jmp     @@_done3
@@_isok3:
        FILD    QWord Ptr L3
        FDiv
@@_done3:
;---------------------
        FST     ZINV
        FILD    QWord Ptr L2
        FMul    ST, ST(1)
        FISTP   U2
        FILD    QWord Ptr L1
        FMul
        FISTP   V2

        Mov     EAX, DWord Ptr U2
        Sub     EAX, DWord Ptr U1
;        JC      @@_nfix3
;        Cmp     EAX, -ICnt4
;        JC      @@_nfix3
;        Xor     EAX, EAX
;@@_nfix3:
        Sar     EAX, IBits4
        Mov     DU, EAX

        Mov     EAX, DWord Ptr V2
        Sub     EAX, DWord Ptr V1
;        JC      @@_nfix4
;        Cmp     EAX, -ICnt4
;        JC      @@_nfix4
;        Xor     EAX, EAX
;@@_nfix4:
        Sar     EAX, IBits4
        Mov     DV, EAX

        Jmp     @@_mcycle

@@_done:

        Pop     DS
        Ret
TLINE16 ENDP

CODE    ENDS

END
